def newton(f,f1,xa,xb,tol): # metodo di Newton
    fa = f(x = xa)
    fb = f(x = xb)
    while (fa*fb > 0): # no roots in the interval
        # assume f monotonic
        if (abs(fa) < abs(fb)):
            xa = xa*9/10
            fa = f(x=xa)
        else:
            xb = xb*11/10
            fb = f(x=xb)
    xn = xb
    delta = -f(x=xn)/f1(x=xn)
    while (abs(delta) > tol * xn): # relative distance
        xn = xn+delta
        delta = -f(x=xn)/f1(x=xn)
    return xn
